import { LitElement, TemplateResult } from 'lit-element';
export declare class WcesFormBuilder extends LitElement {
    param?: FormElementParam<Array<FormElementParam<any>>>;
    columnCount: number;
    catalog: Map<string, FormElementFactory<any, any>>;
    get elements(): (FormElementManager<any, any> | undefined)[] | undefined;
    private _value;
    get value(): {
        [key: string]: any;
    };
    set value(val: {
        [key: string]: any;
    });
    onChange(name: string, value: any): void;
    private _valid;
    get valid(): boolean | undefined;
    onValidityChange(name: string, isValid: boolean): void;
    static styles: import("lit-element").CSSResult[];
    render(): TemplateResult;
}
export interface FormElementFactory<TOptions, TValue> {
    create: (param: FormElementParam<TOptions>) => FormElementManager<TOptions, TValue>;
}
export interface FormElementManager<TOptions, TValue> {
    readonly name: string;
    param: FormElementParam<TOptions>;
    render: (value: TValue, options: FormRenderOptions<TValue>) => TemplateResult;
}
export interface FormRenderOptions<TValue> {
    onChange: (value: TValue) => void;
    onValidityChange: (isValid: boolean) => void;
}
export interface FormElementParam<TOptions> {
    type: string;
    name: string;
    displayName?: string;
    span?: number;
    required?: boolean;
    options: TOptions;
}
