import { LitElement } from 'lit-element';
import { FormElementFactory, FormElementManager, FormElementParam, FormRenderOptions } from '../WcesFormBuilder.js';
export declare class WcesSelectField extends LitElement {
    name: string;
    value: string;
    param?: FormElementParam<SelectFieldOptions>;
    options?: FormRenderOptions<string>;
    static styles: import("lit-element").CSSResult;
    render(): import("lit-element").TemplateResult;
    onChange(e: {
        target: HTMLSelectElement;
    }): void;
    updated(): void;
}
export declare class SelectFieldElementManager implements FormElementManager<SelectFieldOptions, string> {
    param: FormElementParam<SelectFieldOptions>;
    get name(): string;
    constructor(param: FormElementParam<SelectFieldOptions>);
    render(value: string, options: FormRenderOptions<string>): import("lit-element").TemplateResult;
}
export declare class SelectFieldElementFactory implements FormElementFactory<SelectFieldOptions, string> {
    create(param: FormElementParam<SelectFieldOptions>): SelectFieldElementManager;
}
export interface SelectFieldOptions {
    label?: string;
    outlined?: boolean;
    disabled?: boolean;
    icon?: string;
    helper?: string;
    healperPersistent?: boolean;
    validationMessage?: string;
    validityTransform?: (value: string, nativeValidity: ValidityState) => Partial<ValidityState>;
    options: SelectOption[];
}
export interface SelectOption {
    name: string;
    value: string;
}
