import { __decorate } from "tslib";
import { spreadProps } from '@open-wc/lit-helpers/src/spreadProps';
import { css, customElement, html, LitElement, property } from 'lit-element';
import { ifDefined } from 'lit-html/directives/if-defined';
let WcesSelectField = class WcesSelectField extends LitElement {
    constructor() {
        super(...arguments);
        this.value = '';
    }
    render() {
        var _a, _b, _c, _d;
        const props = {
            ...(_a = this.param) === null || _a === void 0 ? void 0 : _a.options,
            options: undefined,
        };
        return html `
      <mwc-select
        id="select"
        name="${this.name}"
        label="${ifDefined((_b = this.param) === null || _b === void 0 ? void 0 : _b.displayName)}"
        fullwidth
        ?required="${(_c = this.param) === null || _c === void 0 ? void 0 : _c.required}"
        .value="${this.value || ''}"
        ...=${spreadProps(props)}
        @change="${this.onChange}"
      >
        <mwc-list-item></mwc-list-item>
        ${(_d = this.param) === null || _d === void 0 ? void 0 : _d.options.options.map(({ name, value }) => html `
            <mwc-list-item value="${value}">${name}</mwc-list-item>
          `)}
      </mwc-select>
    `;
    }
    onChange(e) {
        var _a, _b;
        (_a = this.options) === null || _a === void 0 ? void 0 : _a.onChange(e.target.value);
        (_b = this.options) === null || _b === void 0 ? void 0 : _b.onValidityChange(e.target.checkValidity());
    }
    updated() {
        this.updateComplete.then(() => {
            setTimeout(() => {
                var _a, _b;
                const select = (_a = this.shadowRoot) === null || _a === void 0 ? void 0 : _a.getElementById('select');
                if (select) {
                    (_b = this.options) === null || _b === void 0 ? void 0 : _b.onValidityChange(select.checkValidity());
                }
            }, 1000);
        });
    }
};
WcesSelectField.styles = css `
    mwc-select {
      width: 100%;
    }
  `;
__decorate([
    property({ type: String })
], WcesSelectField.prototype, "name", void 0);
__decorate([
    property({ type: String })
], WcesSelectField.prototype, "value", void 0);
__decorate([
    property({ type: Object })
], WcesSelectField.prototype, "param", void 0);
__decorate([
    property({ type: Object })
], WcesSelectField.prototype, "options", void 0);
WcesSelectField = __decorate([
    customElement('wces-select-field')
], WcesSelectField);
export { WcesSelectField };
export class SelectFieldElementManager {
    constructor(param) {
        this.param = param;
    }
    get name() {
        return this.param.name;
    }
    render(value, options) {
        var _a;
        import('@material/mwc-select');
        import('@material/mwc-list/mwc-list-item');
        return html `
      <wces-select-field
        style="${`grid-column-end: span ${((_a = this.param) === null || _a === void 0 ? void 0 : _a.span) || 1}`}"
        .value="${value}"
        name="${this.name}"
        .param="${this.param}"
        .options="${options}"
      >
      </wces-select-field>
    `;
    }
}
export class SelectFieldElementFactory {
    create(param) {
        return new SelectFieldElementManager(param);
    }
}
//# sourceMappingURL=select-field.js.map