import { TextFieldType } from '@material/mwc-textfield';
import { FormElementFactory, FormElementManager, FormElementParam, FormRenderOptions } from '../WcesFormBuilder.js';
import { LitElement } from 'lit-element';
export declare class WcesTextField extends LitElement {
    name: string;
    value: string;
    param?: FormElementParam<TextFieldOptions>;
    options?: FormRenderOptions<string>;
    static styles: import("lit-element").CSSResult;
    render(): import("lit-html").TemplateResult;
    onChange(e: {
        target: HTMLInputElement;
    }): void;
    updated(): void;
}
export declare class TextFieldElementManager implements FormElementManager<TextFieldOptions, string> {
    param: FormElementParam<TextFieldOptions>;
    get name(): string;
    constructor(param: FormElementParam<TextFieldOptions>);
    render(value: string, options: FormRenderOptions<string>): import("lit-html").TemplateResult;
}
export declare class TextFieldElementFactory implements FormElementFactory<TextFieldOptions, string> {
    create(param: FormElementParam<TextFieldOptions>): TextFieldElementManager;
}
export declare class TextFieldOptions {
    type?: TextFieldType;
    label?: string;
    placeholder?: string;
    prefix?: string;
    suffix?: string;
    icon?: string;
    iconTrailing?: string;
    disabled?: boolean;
    charCounter?: boolean;
    outlined?: boolean;
    helper?: string;
    healperPersistent?: boolean;
    maxLength?: number;
    validationMessage?: string;
    pattern?: string;
    min?: number | string;
    max?: number | string;
    size?: number | null;
    step?: number | null;
    autoValidate?: boolean;
    validityTransform?: (value: string, nativeValidity: ValidityState) => Partial<ValidityState>;
}
