import { __decorate } from "tslib";
import { spreadProps } from '@open-wc/lit-helpers/src/spreadProps';
import { html } from 'lit-html';
import { ifDefined } from 'lit-html/directives/if-defined';
import { LitElement, property, customElement, css } from 'lit-element';
let WcesTextField = class WcesTextField extends LitElement {
    constructor() {
        super(...arguments);
        this.value = '';
    }
    render() {
        var _a, _b, _c;
        return html `
      <mwc-textfield
        id="input"
        name="${this.name}"
        label="${ifDefined((_a = this.param) === null || _a === void 0 ? void 0 : _a.displayName)}"
        ?required="${(_b = this.param) === null || _b === void 0 ? void 0 : _b.required}"
        .value="${this.value || ''}"
        ...=${spreadProps(((_c = this.param) === null || _c === void 0 ? void 0 : _c.options) || {})}
        @change="${this.onChange}"
      ></mwc-textfield>
    `;
    }
    onChange(e) {
        var _a, _b;
        (_a = this.options) === null || _a === void 0 ? void 0 : _a.onChange(e.target.value);
        (_b = this.options) === null || _b === void 0 ? void 0 : _b.onValidityChange(e.target.checkValidity());
    }
    updated() {
        this.updateComplete.then(() => {
            setTimeout(() => {
                var _a, _b;
                const input = (_a = this.shadowRoot) === null || _a === void 0 ? void 0 : _a.getElementById('input');
                if (input) {
                    (_b = this.options) === null || _b === void 0 ? void 0 : _b.onValidityChange(input.checkValidity());
                }
            }, 1000);
        });
    }
};
WcesTextField.styles = css `
    mwc-textfield {
      width: 100%;
    }
  `;
__decorate([
    property({ type: String })
], WcesTextField.prototype, "name", void 0);
__decorate([
    property({ type: String })
], WcesTextField.prototype, "value", void 0);
__decorate([
    property({ type: Object })
], WcesTextField.prototype, "param", void 0);
__decorate([
    property({ type: Object })
], WcesTextField.prototype, "options", void 0);
WcesTextField = __decorate([
    customElement('wces-text-field')
], WcesTextField);
export { WcesTextField };
export class TextFieldElementManager {
    constructor(param) {
        this.param = param;
    }
    get name() {
        return this.param.name;
    }
    render(value, options) {
        var _a;
        import('@material/mwc-textfield');
        return html `
      <wces-text-field
        style="${`grid-column-end: span ${((_a = this.param) === null || _a === void 0 ? void 0 : _a.span) || 1}`}"
        .value="${value}"
        name="${this.name}"
        .param="${this.param}"
        .options="${options}"
      ></wces-text-field>
    `;
    }
}
export class TextFieldElementFactory {
    create(param) {
        return new TextFieldElementManager(param);
    }
}
export class TextFieldOptions {
    constructor() {
        this.type = 'text';
    }
}
//# sourceMappingURL=text-field.js.map