import { html } from 'lit-html';
import { ifDefined } from 'lit-html/directives/if-defined';
export class InputFormElementManager {
    constructor(param) {
        this.param = param;
    }
    get name() {
        return this.param.name;
    }
    render(value, options) {
        return html `
      <input
        type="text"
        style="${`grid-column-end: span ${this.param.span || 1}`}"
        name="${this.name}"
        ?required="${this.param.required}"
        .value="${value || ''}"
        placeholder="${ifDefined(this.param.options.placeholder)}"
        minlength="${ifDefined(this.param.options.minlength)}"
        maxlength="${ifDefined(this.param.options.maxlength)}"

        @change="${(e) => this.onChange(e, options)}"
      />
    `;
    }
    onChange(e, options) {
        options.onChange(e.target.value);
        options.onValidityChange(e.target.checkValidity());
    }
}
export class InputFormElementFactory {
    create(param) {
        return new InputFormElementManager(param);
    }
}
//# sourceMappingURL=input-form-element-manager.js.map